// From the software distribution accompanying the textbook
// "A Practical introduction to Data Structures and Algorithm Analysis,
// Third Edition (C++)" by Clifford A. Shaffer.
// Source code Copyright (C) 2007-2011 by Clifford A. Shaffer.

// Program for testing the Binary Search Tree (BST) implementation

#include "book.h"

// BST implementation
#include "BST.h"

// Warning: This test driver has horrible memory leaks.
// Everytime the program does a remove to "it", the next time "it"
// gets used, that previous int object gets clobbered.
int main()
{
    // Can make "value/E" a non-pointer, but the nullptr checks break
    BST<int, string *> tree_dict;
    
    tree_dict.insert(201, new string("Orange"));
    tree_dict.insert(151, new string("Beet"));
    tree_dict.insert(190, new string("Radish"));
    tree_dict.insert(170, new string("Starfruit"));
    tree_dict.insert(350, new string("Apple"));
    tree_dict.insert(700, new string("Lettuce"));
    tree_dict.insert(10, new string("Pumpkin"));

    *(tree_dict.find(10));
    tree_dict.find(11);

    tree_dict.print();

    tree_dict.remove(10);
    *(tree_dict.remove(1000));

    tree_dict.size();
    tree_dict.size2();
    
    tree_dict.clear();

    // step for destructor/clearhelp
    return 0;
}
